/* 
Subtitles Workgroup: A subtitles creation software with network collaboration suppport
Copyright (C) 2007 smalleye

This program is free software; you can redistribute it and/or modify it under the terms of the 
 * GNU General Public License as published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
 * if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Net.Sockets;

namespace Nikse.SubtitleEdit.Logic.Networking
{
    public class NetworkClient
    {
        public NetworkConnection Connection;
        public NetworkConnection.dlgReceive OnReceive;
        public NetworkConnection.dlgClientDisconnect OnDisconnect;

        public NetworkClient(string host, int port, NetworkConnection.dlgReceive recvevent, NetworkConnection.dlgClientDisconnect discevent)
        {
            TcpClient newClient;
            newClient = new TcpClient(host, port);
            while (!newClient.Connected) ;
            Connection = new NetworkConnection(newClient, 0);
            OnReceive += recvevent;
            OnDisconnect += discevent;
            Connection.OnReceive += OnReceive;
            Connection.OnClientDisconnect += OnDisconnect;
        }

        public void Disconnect()
        {
            Connection.Disconnect();
        }

        public bool Connected
        {
            get
            {
                return Connection.Client.Connected;
            }
        }

        public NetworkOperation Send(NetworkOperation op, bool wait)
        {
            return Connection.Send(op, wait);
        }

        public int GetId()
        {
            return Connection.ConnectionId;
        }

        public void SetId(int id)
        {
            Connection.ConnectionId = id;
        }
    }
}
